Index: trunk/MagicSoft/Mars/msignal/MExtractTime.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5548)
+++ trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5558)
@@ -215,5 +215,4 @@
 void MExtractTime::Print(Option_t *o) const
 {
-    *fLog << all;
     if (IsA()==MExtractTime::Class())
         *fLog << GetDescriptor() << ":" << endl;
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5548)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5558)
@@ -115,4 +115,7 @@
   if (!fSignals)
       return kFALSE;
+
+  *fLog << flush << inf;
+  Print();
   
   return kTRUE;
@@ -141,6 +144,4 @@
     fSignals->SetUsedFADCSlices(fHiGainFirst, fHiGainLast+fHiLoLast, fNumHiGainSamples,
                                 fLoGainFirst, fLoGainLast, fNumLoGainSamples);
-  
-  Print();
 
   return kTRUE;
@@ -244,11 +245,9 @@
 void MExtractTimeAndCharge::Print(Option_t *o) const
 {
-
-  *fLog << all;
   if (IsA()==MExtractTimeAndCharge::Class())
     *fLog << GetDescriptor() << ":" << endl;
   
   *fLog << dec << endl;
-  *fLog << inf << "Taking " << fNumHiGainSamples
+  *fLog << "Taking " << fNumHiGainSamples
         << " HiGain samples from slice " << (Int_t)fHiGainFirst
         << " to " << (Int_t)(fHiGainLast+fHiLoLast) << " incl" << endl;
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 5548)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndChargeDigitalFilter.cc	(revision 5558)
@@ -1012,30 +1012,22 @@
 void MExtractTimeAndChargeDigitalFilter::Print(Option_t *o) const
 {
-
-  *fLog << all;
-  *fLog << GetDescriptor() << ":" << endl;
-
-  MExtractTimeAndCharge::Print(o);
-  *fLog << " Time Shift HiGain:  " << fTimeShiftHiGain << endl;
-  *fLog << " Time Shift LoGain:  " << fTimeShiftLoGain << endl;
-  *fLog << " Window Size HiGain: " << fWindowSizeHiGain << endl;
-  *fLog << " Window Size LoGain: " << fWindowSizeLoGain << endl;
-  *fLog << " Binning Res HiGain: " << fBinningResolutionHiGain << endl;
-  *fLog << " Binning Res LoGain: " << fBinningResolutionHiGain << endl;
-  *fLog << " Weights File:       " << fNameWeightsFile.Data() << endl;
-  
-  TString opt(o);
-  if (!opt.Contains("weights"))
-    return;
-  
-  *fLog << endl;
-  *fLog << inf << "Using the following weights: " << endl;
-  *fLog << "Hi-Gain:" << endl;
-  for (Int_t i=0; i<fBinningResolutionHiGain*fWindowSizeHiGain; i++)
-    *fLog << " " << fAmpWeightsHiGain[i] << " \t " << fTimeWeightsHiGain[i] << endl;
-  
-  *fLog << "Lo-Gain:" << endl;
-  for (Int_t i=0; i<fBinningResolutionLoGain*fWindowSizeLoGain; i++)
-    *fLog << " " << fAmpWeightsLoGain[i] << " \t " << fTimeWeightsLoGain[i] << endl;
-  
+    MExtractTimeAndCharge::Print(o);
+    *fLog << " Time Shift  HiGain: " << fTimeShiftHiGain         << "  LoGain: " << fTimeShiftLoGain << endl;
+    *fLog << " Window Size HiGain: " << fWindowSizeHiGain        << "  LoGain: " << fWindowSizeLoGain << endl;
+    *fLog << " Binning Res HiGain: " << fBinningResolutionHiGain << "  LoGain: " << fBinningResolutionHiGain << endl;
+    *fLog << " Weights File:       " << fNameWeightsFile.Data() << endl;
+
+    TString opt(o);
+    if (!opt.Contains("weights"))
+        return;
+
+    *fLog << endl;
+    *fLog << inf << "Using the following weights: " << endl;
+    *fLog << "Hi-Gain:" << endl;
+    for (Int_t i=0; i<fBinningResolutionHiGain*fWindowSizeHiGain; i++)
+        *fLog << " " << fAmpWeightsHiGain[i] << " \t " << fTimeWeightsHiGain[i] << endl;
+
+    *fLog << "Lo-Gain:" << endl;
+    for (Int_t i=0; i<fBinningResolutionLoGain*fWindowSizeLoGain; i++)
+        *fLog << " " << fAmpWeightsLoGain[i] << " \t " << fTimeWeightsLoGain[i] << endl;
 }
Index: trunk/MagicSoft/Mars/msignal/MExtractor.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 5548)
+++ trunk/MagicSoft/Mars/msignal/MExtractor.cc	(revision 5558)
@@ -412,6 +412,4 @@
 void MExtractor::Print(Option_t *o) const
 {
-    *fLog << all;
-
     if (IsA()==MExtractor::Class())
         *fLog << GetDescriptor() << ":" << endl;
@@ -419,6 +417,5 @@
     *fLog << " Hi Gain Range:  " << (int)fHiGainFirst << " " << (int)fHiGainLast << endl;
     *fLog << " Lo Gain Range:  " << (int)fLoGainFirst << " " << (int)fLoGainLast << endl;
-    *fLog << " Num Samples Hi: " << fNumHiGainSamples << endl;
-    *fLog << " Num Samples Lo: " << fNumHiGainSamples << endl;
     *fLog << " Saturation Lim: " << (int)fSaturationLimit << endl;
-}
+    *fLog << " Num Samples HiGain: " << fNumHiGainSamples << "  LoGain: " << fNumLoGainSamples << endl;
+}