Index: trunk/MagicSoft/Mars/Changelog
===================================================================
--- trunk/MagicSoft/Mars/Changelog	(revision 5599)
+++ trunk/MagicSoft/Mars/Changelog	(revision 5601)
@@ -21,40 +21,74 @@
                                                  -*-*- END OF LINE -*-*-
 
+ 2004/12/15: Thomas Bretz (important bugfixes for callisto)
+
+   * callisto.rc:
+     - fixed wrong names in comments
+
+   * mjobs/MJCalibrateSignal.cc:
+     - fixed naming of the two MPedCalcFromLoGain
+     - set correct pedestal container for extractor
+
+   * msignal/MArrivalTimeCam.h:
+     - added Reset() function
+
+   * msignal/MExtractTime.cc:
+     - replaced parts of the common PreProcess by new function PreProcessStd
+
+   * msignal/MExtractTimeAndCharge.cc:
+     - removed Clear() in Process() -- this is automatically done by 
+       Reset()
+
+   * msignal/MExtractedSignalCam.h:
+     - added Reset() function
+
+   * msignal/MExtractor.[h,cc]:
+     - moved some common parts of PreProcess to new function PreProcessStd
+       this fixed the problem that searching for fPedestals was
+       overwritten in MExtractTime
+
+
+
  2004/12/15: Abelardo Moralejo
 
-  * mmc/MMcConfigRunHeader.h
-    - added data member fPmtTimeJitter, sigma of gaussian of the time
-      jitter introduced in the time of each photoelectron.
+   * mmc/MMcConfigRunHeader.h
+     - added data member fPmtTimeJitter, sigma of gaussian of the time
+       jitter introduced in the time of each photoelectron.
+
+
 
  2004/12/14: Markus Gaug
 
-  * msignal/MExtractor.[h,cc]
-    - add possibility to set pedestal pointer from outside
-
-  * msignal/MExtractTimeAndCharge.[h,cc]
-    - make modification of extraction window only for case of now 
-      high-gain saturation.
-
-  * msignal/MExtractTimeAndChargeSpline.cc
-    - fixed some smaller bugs for special cases
-
-  * mcalib/MCalibrationIntensityChargeCam.[h,cc]
-    - implemented automatic plotting of Razmik plot and others
+   * msignal/MExtractor.[h,cc]
+     - add possibility to set pedestal pointer from outside
+
+   * msignal/MExtractTimeAndCharge.[h,cc]
+     - make modification of extraction window only for case of now 
+       high-gain saturation.
+
+   * msignal/MExtractTimeAndChargeSpline.cc
+     - fixed some smaller bugs for special cases
+
+   * mcalib/MCalibrationIntensityChargeCam.[h,cc]
+     - implemented automatic plotting of Razmik plot and others
+
 
 
  2004/12/14: Markus Gaug and Abelardo Moralejo
 
-  * msignal/MExtractFixedWindowPeakSearch.cc
-    - adjusted the offset from peak search window to extraction window
-      such that they start at the same slice for the case: 
-      fOffsetFromWindow=0. This was the original intention of the 
-      extractor and had been lost at some place. Instead, the default 
-      (fOffsetFromWindow=1) did before correspond to an offset of 2 
-      slices which gave wrong results for the calibration and further
-      default settings. 
-    - Changed one comparison: (Byte_t - Byte_t) > 0 to (Byte_t > Byte_t)
-      since the first mode is always true (a negative "byte" simply gives 
-      256-difference. The version before could have lead to crashes from 
-      time to time.
+   * msignal/MExtractFixedWindowPeakSearch.cc
+     - adjusted the offset from peak search window to extraction window
+       such that they start at the same slice for the case: 
+       fOffsetFromWindow=0. This was the original intention of the 
+       extractor and had been lost at some place. Instead, the default 
+       (fOffsetFromWindow=1) did before correspond to an offset of 2 
+       slices which gave wrong results for the calibration and further
+       default settings. 
+     - Changed one comparison: (Byte_t - Byte_t) > 0 to (Byte_t > Byte_t)
+       since the first mode is always true (a negative "byte" simply gives 
+       256-difference. The version before could have lead to crashes from 
+       time to time.
+
+
 
  2004/12/12: Abelardo Moralejo
@@ -65,19 +99,24 @@
       warning.
 
+
+
  2004/12/09: Markus Gaug
   
-  * mhcalib/MHCalibrationPix.[h,cc]
-    - fixed a bug in Reset(), fSaturation was not resetted before. 
-      Affects only intensity calibraion.
-  * mhcalib/MHGausEvents.cc
-    - fixed bug in Reset(), histogram ranges were not reset before.
-      Affects only intensity calibraion.
+   * mhcalib/MHCalibrationPix.[h,cc]
+     - fixed a bug in Reset(), fSaturation was not resetted before. 
+       Affects only intensity calibraion.
+   * mhcalib/MHGausEvents.cc
+     - fixed bug in Reset(), histogram ranges were not reset before.
+       Affects only intensity calibraion.
+
+
 
  2004/12/09: Thomas Bretz
 
- * mbadpixels/MBadPixelsTreat.cc:
-   - set default in constructor to UseInterpolation, ProcessPedestalEvt
-     and ProcessTimes which is the callisto default
-   - enhanced comments in output
+  * mbadpixels/MBadPixelsTreat.cc:
+    - set default in constructor to UseInterpolation, ProcessPedestalEvt
+      and ProcessTimes which is the callisto default
+    - enhanced comments in output
+
 
 