Index: trunk/MagicSoft/TDAS-Extractor/Performance.tex
===================================================================
--- trunk/MagicSoft/TDAS-Extractor/Performance.tex	(revision 5632)
+++ trunk/MagicSoft/TDAS-Extractor/Performance.tex	(revision 5637)
@@ -132,4 +132,11 @@
 \end{figure}
 
+\begin{figure}[htp]
+\centering
+\includegraphics[height=0.95\textheight]{UnsuitVsExtractor-23LedsBlue-Colour-00.eps}
+\caption{Uncalibrated pixels and pixels outside of the Gaussian distribution for a high-intensity blue pulse.}
+\label{fig:unsuited:23ledsblue}
+\end{figure}
+
 One can see that in general, big extraction windows raise the 
 number of un-calibrated pixels and are thus less stable. Especially for the very low-intensity 
@@ -213,9 +220,14 @@
 \par
 Figures~\ref{fig:phe:5ledsuv},~\ref{fig:phe:1leduv},~\ref{fig:phe:23ledsblue}~and~\ref{fig:phe:2ledsgreen} show 
-some of the obtained results. Although one can see an amazing stability for the standard 5Leds UV pulse, there 
-is a considerable difference for all shown non-standard pulses. Especially the pulses from green and blue LEDs 
+some of the obtained results. Although one can see an amazing stability for the standard 5Leds UV pulse, 
+there is a considerable difference for all shown non-standard pulses. Especially the pulses from green 
+and blue LEDs 
 show a clear dependency on the extraction window of the number of photo-electrons. Only the largest 
 extraction windows seem to catch the entire range of (jittering) secondary pulses and get also the ratio 
 of outer vs. inner pixels right.
+\par
+The strongest discrepancy is observed in the low-gain extraction (fig.~\ref{fig:phe:23ledsblue}) where all 
+fixed window extractors 
+
 
 \begin{figure}[htp]
@@ -256,4 +268,16 @@
 
 
+\begin{figure}[htp]
+\centering
+\includegraphics[height=0.92\textheight]{PheVsExtractor-23LedsBlue-Colour-00.eps}
+\caption{Number of photo-electrons from a typical, high-gain saturating calibration pulse of colour blue, 
+reconstructed with each of the tested signal extractors. 
+The first plots shows the number of photo-electrons obtained for the inner pixels, the second one 
+for the outer pixels and the third shows the ratio of the mean number of photo-electrons for the 
+outer pixels divided by the mean number of photo-electrons for the inner pixels. Points 
+denote the mean of all not-excluded pixels, the error bars their RMS.}
+\label{fig:phe:23ledsblue}
+\end{figure}
+
 One can see that all extractor using a large window belong to the class of extractors being affected 
 by the secondary pulses. The only exception to this rule is the digital filter which - despite of its 
@@ -295,6 +319,51 @@
 \subsubsection{Time resolution}
 
-
-
+\begin{figure}[htp]
+\centering
+\includegraphics[height=0.25\textheight]{RelArrTime_Pixel97_10LedUV_Extractor32.eps}
+\includegraphics[height=0.25\textheight]{RelArrTime_Pixel97_10LedUV_Extractor23.eps}
+\caption{Example of a two distributions of relative arrival times of an inner pixel with respect to 
+the arrival time of the reference pixel Nr. 1. The left plot shows the result using the digital filter
+ (extractor \#32), the right plot shows the result obtained with the half-maximum of the spline. A 
+medium sized UV-pulse (10Leds UV) has been used which does not saturate the high-gain readout channel.}
+\label{fig:reltimesinner}
+\end{figure}
+
+\begin{figure}[htp]
+\centering
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel400_10LedUV_Extractor32.eps}
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel400_10LedUV_Extractor23.eps}
+\caption{Example of a two distributions of relative arrival times of an outer pixel with respect to 
+the arrival time of the reference pixel Nr. 1. The left plot shows the result using the digital filter
+ (extractor \#32), the right plot shows the result obtained with the half-maximum of the spline. A 
+medium sized UV-pulse (10Leds UV) has been used which does not saturate the high-gain readout channel.}
+\label{fig:reltimesouter}
+\end{figure}
+
+\begin{figure}[htp]
+\centering
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel97_10LedBlue_Extractor32.eps}
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel97_10LedBlue_Extractor23.eps}
+\caption{Example of a two distributions of relative arrival times of an inner pixel with respect to 
+the arrival time of the reference pixel Nr. 1. The left plot shows the result using the digital filter
+ (extractor \#32), the right plot shows the result obtained with the half-maximum of the spline. A 
+medium sized Blue-pulse (10Leds Blue) has been used which saturates the high-gain readout channel.}
+\label{fig:reltimesinner}
+\end{figure}
+
+\begin{figure}[htp]
+\centering
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel400_10LedBlue_Extractor32.eps}
+\includegraphics[width=0.45\linewidth]{RelArrTime_Pixel400_10LedBlue_Extractor23.eps}
+\caption{Example of a two distributions of relative arrival times of an outer pixel with respect to 
+the arrival time of the reference pixel Nr. 1. The left plot shows the result using the digital filter
+ (extractor \#32), the right plot shows the result obtained with the half-maximum of the spline. A 
+medium sized Blue-pulse (10Leds Blue) has been used which saturates the high-gain readout channel.}
+\label{fig:reltimesouter}
+\end{figure}
+
+
+
+\clearpage
 
 \subsection{Pulpo Pulses}
@@ -317,3 +386,4 @@
 %%% TeX-master: "MAGIC_signal_reco."
 %%% TeX-master: "MAGIC_signal_reco"
+%%% TeX-master: "MAGIC_signal_reco"
 %%% End: 